from process import *
from schedule import *

class FCFS(Schedule):
  """First Come First Served algorithm implementation"""
  
  def solve(self):
    self._prcs.sort(Process.__durcmp__)
    self._prcs.sort(Process.__strcmp__)
    
    result = []
    i=0
    count = float(len(self._prcs))
    while i < len(self._prcs):
      p = self._prcs.pop(0)
      self.response += p.waiting() + p.duration()
      self.waiting += p.waiting()
      p.advance()
      print p
      result.append(p)
      end = p.start()+p.duration()
      
      j=0
      while (j < len(self._prcs)) and (self._prcs[j].start() < end):
	self._prcs[j].restart(end)
	j+=1
    self.response /= count
    self.waiting /= count
    self.turnaround = self.response
    return result