from process import *
from schedule import *
from random import uniform

class Lottery(Schedule):
  """Lottery Scheduling Implementation"""
  
  def solve(self):
    self._prcs.sort(Process.__strcmp__)
    count = float(len(self._prcs))
    
    result = []
    while len(self._prcs):
      c=1
      i=1
      while (i < len(self._prcs)) and (self._prcs[i].start() == self._prcs[0].start()):
	c+=1
	i+=1
	  
      index = int ( uniform(0, c-0.5) )
      p = self._prcs.pop(index)
      p.advance()
      result.append(p)
      print p
      self.response += p.waiting() + p.duration()
      self.waiting += p.waiting()
      end = p.start()+p.duration()
      
      j=0
      while (j < len(self._prcs)) and (self._prcs[j].start() < end):
	self._prcs[j].restart(end)
	j+=1
	
    self.response /= count
    self.waiting /= count
    self.turnaround = self.response
    
    return result