from abc import ABCMeta, abstractproperty
from copy import deepcopy


class Schedule(object):
  __metaclass__ = ABCMeta
  
  def __init__(self, prcs=None):
    self._prcs = deepcopy(prcs)
    self.response = 0
    self.waiting = 0
    self.turnaround = 0

  def prcs(self):
    return self._prcs
    
    
  @abstractproperty
  def solve (self, interval): #returns jobs in scheduled order
    pass