from process import *
from schedule import *

class SRTN(Schedule):
  """Shortest remaining time next Implementation"""
  
  def restartJobs(self, time):
    for i in self._prcs:
	  if i.start() < time:
	    i.restart(time)
    
    
  def takeFirst (self):
    i = 1
    pi = 0
    first = self._prcs[pi].start()
    while i < len(self._prcs):
      if self._prcs[i].start() < first:
	first = self._prcs[i].start()
	pi = i
      i+=1
    return self._prcs.pop(pi)

  def solve (self):
    self._prcs.sort(Process.__rmncmp__)
    count = float(len(self._prcs))
    result = []
    p = self.takeFirst()

    while len(self._prcs):
      #trying to find next process
      group = [ self._prcs.index(i) for i in self._prcs if i.remaining() < p.remaining() - i.start() ]
      if not group:
	#take cpu to finish process
	end = p.start() + p.remaining()
	if not p.progress():
	  self.response += end - p.realStart()
	p.advance()
	self.restartJobs(end)
	self.turnaround += end - p.realStart()
	self.waiting += p.waiting()
	print p
	result.append(p)
	p = self.takeFirst()
	continue
	
      np = self._prcs[group[0]]
      fi = group[0]
      for i in group:
	if self._prcs[group[i]].start() < self._prcs[group[fi]].start():
	  fi = i
      end = min(np.start(), p.start() + p.remaining())
      if not p.progress():
	  self.response += end - p.start()
      np = self._prcs.pop(group[fi])
      self.restartJobs(end)
      p.advance(np.start() - p.start())
      print p
      result.append(p)
      if p.progress() < 100:
	p.restart(np.start())
	self._prcs.append(p)
	self._prcs.sort(Process.__rmncmp__)
	p = np
      else:
	self.turnaround += end - p.realStart()
	self.waiting += p.waiting()
	p = self.takeFirst()
      
    self.turnaround += p.remaining() + p.waiting()
    self.waiting += p.waiting()
    p.advance()
    print p
    result.append(p)

    self.turnaround /= count
    self.waiting /= count
    self.response /= count
    return result